HDU 3415 Max Sum of Max-K-sub-sequence(单调队列)

HDU 3415 Max Sum of Max-K-sub-sequence(单调队列)

大家好,又见面了,我是全栈君,今天给大家准备了Idea注册码。

转载请注明出处:http://blog.csdn.net/u012860063

Max Sum of Max-K-sub-sequence

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 5791    Accepted Submission(s): 2083

Problem Description
Given a circle sequence A[1],A[2],A[3]……A[n]. Circle sequence means the left neighbour of A[1] is A[n] , and the right neighbour of A[n] is A[1].

Now your job is to calculate the max sum of a Max-K-sub-sequence. Max-K-sub-sequence means a continuous non-empty sub-sequence which length not exceed K.
 

Input
The first line of the input contains an integer T(1<=T<=100) which means the number of test cases.

Then T lines follow, each line starts with two integers N , K(1<=N<=100000 , 1<=K<=N), then N integers followed(all the integers are between -1000 and 1000).
 

Output
For each test case, you should output a line contains three integers, the Max Sum in the sequence, the start position of the sub-sequence, the end position of the sub-sequence. If there are more than one result, output the minimum start position, if still more than one , output the minimum length of them.
 

Sample Input
   
   
4 6 3 6 -1 2 -6 5 -5 6 4 6 -1 2 -6 5 -5 6 3 -1 2 -6 5 -5 6 6 6 -1 -1 -1 -1 -1 -1

 

Sample Output
   
   
7 1 3 7 1 3 7 6 2 -1 1 1


附上别人的思路:

单调队列即保持队列中的元素单调递增(或递减)的这样一个队列,能够从两头删除。仅仅能从队尾插入。单调队列的详细作用在于。因为保持队列中的元素满足单调性,对于上述问题中的每一个j,能够用O(1)的时间找到相应的s[i]。(保持队列中的元素单调增的话,队首元素便是所要的元素了)。

维护方法:对于每一个j,我们插入s[j-1](为什么不是s[j]?

队列里面维护的是区间開始的下标,j是区间结束的下标)。插入时从队尾插入。为了保证队列的单调性,我们从队尾開始删除元素,直到队尾元素比当前须要插入的元素优(本题中是值比待插入元素小。位置比待插入元素靠前。只是后面这一个条件能够不考虑),就将当前元素插入到队尾。之所以能够将之前的队列尾部元素所有删除,是由于它们已经不可能成为最优的元素了。由于当前要插入的元素位置比它们靠前,值比它们小。我们要找的,是满足(i>=j-k+1)的i中最小的s[i],位置越大越可能成为后面的j的最优s[i]。

在插入元素后,从队首開始,将不符合限制条件(i>=j-k+1)的元素所有删除,此时队列一定不为空。

(由于刚刚插入了一个一定符合条件的元素)

代码例如以下:(看了别人的才做出来的,汗)

#include <cstdio>
#include <cstring>
#include <queue>
#include <algorithm>
#include <iostream>
using namespace std;
#define INF 0x3fffffff
int sum[100047],a[200047];
int main()
{
	int t,i,n,m,k,head,end;
	scanf("%d",&t);
	while(t--)
	{
		memset(sum,0,sizeof(sum));
		scanf("%d%d",&n,&k);
		for(i = 1 ; i <= n ; i++)
		{
			scanf("%d",&a[i]);
			sum[i] = sum[i-1]+a[i];//将前i项和所有存入sum数组中
		}
		for(i = n+1 ; i < n+k ; i++)
		{
			sum[i] = sum[i-1]+a[i-n];//将前n+k-1项和所有存入sum数组中
		}
		int ans = -INF;//初始化ans为最小
		deque<int>Q;
		Q.clear();//清空双向队列
		for(i = 1 ; i < n+k ; i++)
		{
			while(!Q.empty() && sum[i-1] < sum[Q.back()])//保持队列的单调性(递增)
				Q.pop_back();
			while(!Q.empty() && i-k > Q.front())//超过k的长度则消除队列前面的元素
				Q.pop_front();
			Q.push_back(i-1);
			if(ans < sum[i]-sum[Q.front()])//假设当前的值比ans大就更新ans的值
			{                              //记录,sum[n]-sum[m]所得出的是n-1到m+1之间的和
				ans = sum[i]-sum[Q.front()];
				head = Q.front()+1;
				end = i;
			}
		}
		if(end > n)//标记的点大于了n则循环
			end%=n;
		if(head > n)//标记的点大于了n则循环
			head%=n;
		printf("%d %d %d\n",ans,head,end);
	}
	return 0;
}

版权声明:本文博主原创文章,博客,未经同意不得转载。

版权声明:本文内容由互联网用户自发贡献,该文观点仅代表作者本人。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。如发现本站有涉嫌侵权/违法违规的内容, 请发送邮件至 举报,一经查实,本站将立刻删除。

发布者:全栈程序员-用户IM,转载请注明出处:https://javaforall.cn/116990.html原文链接:https://javaforall.cn

【正版授权,激活自己账号】: Jetbrains全家桶Ide使用,1年售后保障,每天仅需1毛

【官方授权 正版激活】: 官方授权 正版激活 支持Jetbrains家族下所有IDE 使用个人JB账号...

(0)


相关推荐

发表回复

您的电子邮箱地址不会被公开。

关注全栈程序员社区公众号